// Copyright 2022 The Gitea Authors. All rights reserved.
// SPDX-License-Identifier: MIT

package main

import (
	"os"
	"path/filepath"
	"strconv"
	"strings"
	"syscall"

	"github.com/gokrazy/gokrazy"
)

func getEnvL(env string, def ...string) []string {
	res := strings.Trim(os.Getenv(env), ",")
	if res == "" {
		return def
	}
	return strings.Split(res, ",")
}

func getEnvI(env string, def int) int {
	e := os.Getenv(env)
	res, err := strconv.Atoi(e)
	if e == "" || err != nil {
		return def
	}
	return res
}
func main() {
	if len(os.Args) < 2 {
		gokrazy.DontStartOnBoot()
	}
	executable := os.Args[1]
	if !filepath.IsAbs(executable) {
		executable = filepath.Join("/user", executable)
	}
	mustDropPrivileges(getEnvI("GOKRAZY_UID", 4), getEnvI("GOKRAZY_GID", 4), getEnvL("GOKRAZY_PRIVS")...)
	// run the command
	syscall.Exec(executable, os.Args[1:], os.Environ())
}
